Subject: Re: [PATCH net-next v9 0/6] add ethernet driver for Tehuti Networks TN40xx chips

From: "Russell King (Oracle)" <[email-masked]>
Date: Sun, 9 Jun 2024 14:48:41 +0100

On Sun, Jun 09, 2024 at 02:40:03PM +0200, Hans-Frieder Vogt wrote:
> --- a/drivers/net/ethernet/tehuti/tn40_phy.c    2024-06-06
> 06:43:40.865474664 +0200
> +++ b/drivers/net/ethernet/tehuti/tn40_phy.c    2024-06-06
> 18:57:01.978776712 +0200
> @@ -54,6 +54,8 @@ int tn40_phy_register(struct tn40_priv *
>                 return -1;
>         }
> 
> +       __set_bit(PHY_INTERFACE_MODE_XAUI, phydev->host_interfaces);
> +
>         config = &priv->phylink_config;
>         config->dev = &priv->ndev->dev;
>         config->type = PHYLINK_NETDEV;

This shouldn't be done - host_interfaces is really only for SFPs, and
it suggests that the 88x3310 isn't properly configured with pinstrapping
for the correct MAC type (which determines the interface mode to be used
to communicate with the MAC.)

I'm not sure what to suggest here, other than further debug (e.g. what
interface mode is the 88x3310 trying to use without this?)

> I have to mention, though, that the phy-drivers for x3310 and aqr105 are
> not yet ready and will also need some changes related to the firmware
> loading, because for most (all?) of the Tehuti-based cards the phy
> firmware has to be uploaded via MDIO.

That's problematical - as I understand it, the 88x3310 firmware at least
is not freely redistributable (we've run into this with other
platforms that do not program the SPI flash attached to the 88x3310
and been told my Marvell that the firmware can't be made available as
part of e.g. linux-firmware.)

So quite what we do with the 88x3310 based boards that don't have
firmware, I'm not sure, but it seems given the non-distributable
firmware issue, that's going to be hard.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!